Subject: Re: Mips cross compiler. Help!
From: [email-masked] (Kai Ruottu)

14 Apr 1998 00:44:33 -0700
Message-ID: <[email-masked]>
References: <[email-masked]>
Reply-To: [email-masked]
Mime-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7BIT
To: [email-masked]
Cc: [email-masked], [email-masked]

Ron Karpel <[email-masked]> wrote:

> Are you sure you need libgcc2.a? I believe you only need it if your target is a
> mips box running an operating system. Most embedded system do not require this.
> If you have to have it, I believe you need to compile it on a gnu port running
> on your mips box.

 Making all the libgcc.a's should succeed however...
 
> In my case, I just disabled libgcc creation from the command line of the make
> file. Mt target is an embedded box that have no operating system.

> David Linsley wrote:
> > I'm trying to make a Mips Cross compiler, hosting on NT4 with the B19
> > release of gnu-win32.
> >
> > The target I'm trying to build for is mips-elf (though I'd really like to
> > build for mips64vr4300 but this seems to be internal to Cygnus only,
> > judging by the test in the configure files), and have copied the mips files
> > from the opcodes directory of 2.8.0 (standard gcc release) into the opcodes
> > directroy of B19/src
> >
> > Binutils builds fine, but gcc fails when trying to compile libgcc2.a - it
> > compiles _muldi3 first and fails with the response:
> >
> > c:\temp\cc001056.s :74 Error opcode requires -mips15 or greater 'dsli'
> > Also followed by
> > 75 'dsra' 76 'dsra' 77 mult 78 mflo
> >
> > 80 Internal Error!
> > Assertion failed in macro-build at ./config/tc-mips.c line 2357
> > Please report this bug

  When trying a 'mips-elf32' target compiler with gcc-2.8.1 sources I found :

  There seems to be a bug in 'config/mips/elf.h' and 'config/mips/elf64.h',
both using the 'ASM_FINAL_SPEC'  definition in 'config/mips/mips.h', which
says that we must use the 'mips-tfile' utility when assembling... But I think 
this is needed only with the ECOFF files.  So, add the following line:

	#undef ASM_FINAL_SPEC

after the

	#include "mips/ecoff.h"

in the file 'config/mips/elf.h',  and after the

	#include "mips/mips.h"

in the file 'config/mips/elf64.h' 

BTW. The 'mips-tfile' and 'mips-tfile' utilities can be built only using the 
info in the 'native' MIPS-headers, but  it's possible to build them for
'i386-cygwin32' host (or for something else non-mips), as I did for a 
Win32-to-mips-ultrix4 cross-compiler....

Hope this can help you a little 
forwards... 

Cheers, Kai
 
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".